#!/usr/bin/perl -w

# Copyright 2015 Kevin Ryde
#
# This file is part of apt-reverse.
#
# apt-reverse is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# apt-reverse is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with apt-reverse.  If not, see <http://www.gnu.org/licenses/>.


# /usr/share/doc/libapt-pkg-doc/html

use 5.010;
use strict;
use warnings;
use AptPkg::Cache;

# uncomment this to run the ### lines
use Smart::Comments;

my $name = '0ad';

my $cache = AptPkg::Cache->new;
print "cache $cache\n";
# $cache keys are package names
my @cfiles = $cache->files;
foreach my $cfile (@cfiles) {
  print "  cfile $cfile\n";
}

my $pkgrecords = $cache->packages;
print "pkgrecords $pkgrecords\n";

print "\n";
my $p = $cache->{$name} || die "don't know anything about package: $name\n";
print "p $p\n";
foreach my $key (keys %$p) {
  print "  $key  ",$p->{$key}//'undef',"\n";
}
my $verlist = $p->{VersionList} || die "no versions of: $name";
print "VersionList length ",scalar(@$verlist),"\n";

my $ver = $verlist->[0];
print "\n";
print "ver $ver\n";
foreach my $key (keys %$ver) {
  print "  $key  ",$ver->{$key}//'undef',"\n";
}
# print "Size ",$ver->{'Size'}//'undef',"\n";
# print "ParentPkg ",$ver->{'ParentPkg'}//'undef',"\n";
# print "ShortDesc ",$ver->{'ShortDesc'}//'undef',"\n";
# print "LongDesc ",$ver->{'LongDesc'}//'undef',"\n";

my $k = $pkgrecords->lookup($name);
print "  k $k\n";
### $k

my $desc_list = $ver->{'DescriptionList'};
print "DescriptionList ",$desc_list//"undef\n";
print "  length ",scalar(@$desc_list),"\n";
foreach my $d (@$desc_list) {
  print "  d $d\n";
  foreach my $key (keys %$d) {
    print "    $key  ",$d->{$key}//'undef',"\n";
  }
  my $f = $d->{'FileList'};
  print "  f $f\n";
  foreach my $key (keys %$f) {
    print "    $key  ",$f->{$key}//'undef',"\n";
  }
  my $fp = $f->{'File'};
  print "    fp $f\n";
  foreach my $key (keys %$fp) {
    print "      $key  ",$fp->{$key}//'undef',"\n";
  }
  print "\n";
}

my $t = $ver->{'TranslatedDescription'};
print "t $t\n";
foreach my $key (keys %$t) {
  print "  $key  ",$t->{$key}//'undef',"\n";
}
my $tf = $t->{'FileList'};
print "  tf $tf\n";
foreach my $key (keys %$tf) {
  print "    $key  ",$tf->{$key}//'undef',"\n";
}
my $tfp = $tf->{'File'};
print "  tfp $tfp\n";
foreach my $key (keys %$tfp) {
  print "    $key  ",$tfp->{$key}//'undef',"\n";
}
# my $tf = $t->{'FileList'};
# print "  FileList $tf\n";
# print "    tf keys: ",join(" ",keys %$tf),"\n";
# print "    File ",$tf->{'File'},"\n";
# my $tfp = $tf->{'File'};
# print "    tfp keys: ",join(" ",keys %$tfp),"\n";
# print "      FileName ",$tf->{'FileName'}//'undef',"\n";
# print "      IndexType ",$tf->{'IndexType'}//'undef',"\n";
# print "      Index ",$tf->{'Index'}//'undef',"\n";
# print "      IsOk ",$tf->{'IsOk'}//'undef',"\n";

# my $n = $tfp->Lookup($name);
# ### $n

# my $trans = $ver->{'TranslatedDescription'};
# print " md5 ",$ver->{'md5'}//'undef',"\n";
# ### $trans_filelist
#
# my $telem = $trans->{$name} || die "don't know anything about package: $name\n";
